
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" lang="fr">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>Pixel &#8212; Documentation Segmentation Image 4.0</title>
    <link rel="stylesheet" href="../_static/nature.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../" src="../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/translations.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Recherche" href="../search.html" /> 
  </head><body>
<div style="background-color: white; text-align: left; padding: 10px 10px 15px 15px">
  <a href="../index.html">
  <img src="../_static/logo.png" border="0" alt="Segmentation Image"/>
  </a>
</div>

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="Index général"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Index des modules Python"
             >modules</a> |</li>
<li><a href="../index.html">Segmentation Image home</a>| </li>
<li><a href="../contents.html">Documentation </a> &raquo;</li>

          <li class="nav-item nav-item-1"><a href="index.html" accesskey="U">Code du module</a> &#187;</li> 
      </ul>
    </div>

      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none" role="search">
  <h3>Recherche rapide</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Code source de Pixel</h1><div class="highlight"><pre>
<span></span><span class="c1">#####################################</span>
<span class="c1"># Cecile Prouteau</span>
<span class="c1"># CTES Projet Math-Info</span>
<span class="c1"># Projet segmentation d&#39;image</span>
<span class="c1"># 15/03/2019</span>
<span class="c1"># Classe Pixel Version 3.0</span>
<span class="c1">#####################################</span>
<span class="kn">import</span> <span class="nn">math</span>

<span class="c1">### DEBUT de la classe Pixel</span>
<span class="c1">### contient la recherche des voisins , on se place du point de vue des coordonnées sur l&#39;image</span>
<div class="viewcode-block" id="Pixel"><a class="viewcode-back" href="../tec_doc.html#Gradient.Pixel">[docs]</a><span class="k">class</span> <span class="nc">Pixel</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;</span>

<span class="sd">    **LES METHODES**</span>
<span class="sd">     </span>
<span class="sd">    &quot;&quot;&quot;</span>
    
<div class="viewcode-block" id="Pixel.__init__"><a class="viewcode-back" href="../tec_doc.html#Gradient.Pixel.__init__">[docs]</a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">x</span><span class="p">,</span><span class="n">y</span><span class="p">,</span><span class="n">val</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Constructeur d&#39;un objet Pixel</span>
<span class="sd">        </span>
<span class="sd">        Construit un sommet à partir des coordonnées d&#39;un pixel sur une image</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Sommet </span>
<span class="sd">        :type self: Sommet</span>
<span class="sd">        </span>
<span class="sd">        :param x: abscisse du point sur l&#39;image</span>
<span class="sd">        :type FilePath: int  </span>
<span class="sd">        </span>
<span class="sd">        </span>
<span class="sd">        :param y: ordonnée du point  </span>
<span class="sd">        :type FilePath: int      </span>
<span class="sd">        </span>
<span class="sd">        :param v: valeur du point  </span>
<span class="sd">        :type FilePath: int </span>
<span class="sd">        </span>
<span class="sd">        :return: Objet Sommet</span>
<span class="sd">        :rtype: Sommet</span>
<span class="sd">        </span>
<span class="sd">        Liste des champs de la classe</span>
<span class="sd">        </span>
<span class="sd">        * self.x abscisse </span>
<span class="sd">        * self.y ordonnée</span>
<span class="sd">        * self.val valeur du pixel self</span>
<span class="sd">        * self.zone indique dans quelle zone se trouve le pixel </span>
<span class="sd">        * self.liste_coord_voisins contiendra la liste des coordonnées des voisins du pixel sur l&#39;image ; initialisé à []</span>
<span class="sd">        </span>
<span class="sd">        Pour les lignes et les colonnes je me place du point de vue de l&#39;image. </span>
<span class="sd">        Dans le tableau numpy, les coordonnées sont inversées.</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">x</span><span class="o">=</span><span class="n">x</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">y</span><span class="o">=</span><span class="n">y</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="o">=</span><span class="n">val</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">zone</span><span class="o">=-</span><span class="mi">1</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">liste_coord_voisins</span><span class="o">=</span><span class="p">[]</span></div>
        
<div class="viewcode-block" id="Pixel.maj_val"><a class="viewcode-back" href="../tec_doc.html#Gradient.Pixel.maj_val">[docs]</a>    <span class="k">def</span> <span class="nf">maj_val</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">val</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Procedure qui met à jour l&#39;attribu self.val avec la valeur val</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Sommet </span>
<span class="sd">        :type self: Sommet</span>
<span class="sd">        </span>
<span class="sd">        :param val: entier à pour mise à jour du numéro de sommet</span>
<span class="sd">        :type val: int  </span>
<span class="sd">        </span>
<span class="sd">        :return: None </span>
<span class="sd">        :rtype: None object</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="o">=</span><span class="n">val</span></div>
        
<div class="viewcode-block" id="Pixel.maj_zone"><a class="viewcode-back" href="../tec_doc.html#Gradient.Pixel.maj_zone">[docs]</a>    <span class="k">def</span> <span class="nf">maj_zone</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">zone</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Procedure qui met à jour l&#39;attribu self.zone avec la valeur zone</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Sommet </span>
<span class="sd">        :type self: Sommet</span>
<span class="sd">        </span>
<span class="sd">        :param zone: entier à pour mise à jour de la zone d&#39;appartenance au sommet</span>
<span class="sd">        :type zone: int  </span>
<span class="sd">        </span>
<span class="sd">        :return: None </span>
<span class="sd">        :rtype: None object</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">zone</span><span class="o">=</span><span class="n">zone</span></div>
    
<div class="viewcode-block" id="Pixel.maj_liste_coord_voisins"><a class="viewcode-back" href="../tec_doc.html#Gradient.Pixel.maj_liste_coord_voisins">[docs]</a>    <span class="k">def</span> <span class="nf">maj_liste_coord_voisins</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">liste</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Procedure qui met à jour l&#39;attribu self.zone avec la valeur zone</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Sommet </span>
<span class="sd">        :type self: Sommet</span>
<span class="sd">        </span>
<span class="sd">        :param liste: liste de coordonnées à ajouter à self.liste_coord_voisins</span>
<span class="sd">        :type liste: List </span>
<span class="sd">        </span>
<span class="sd">        :return: None </span>
<span class="sd">        :rtype: None object</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">for</span>  <span class="n">element</span> <span class="ow">in</span> <span class="n">liste</span><span class="p">:</span>
              <span class="bp">self</span><span class="o">.</span><span class="n">liste_coord_voisins</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">element</span><span class="p">)</span></div>
   
<div class="viewcode-block" id="Pixel.coord_voisin"><a class="viewcode-back" href="../tec_doc.html#Gradient.Pixel.coord_voisin">[docs]</a>    <span class="k">def</span> <span class="nf">coord_voisin</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">direction</span><span class="p">):</span>
        
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        :param self: Objet Sommet </span>
<span class="sd">        :type self: Sommet</span>
<span class="sd">        </span>
<span class="sd">        :param direction: chaine de caractère parmi &#39;droite&#39;, &#39;gauche&#39;, &#39;haut&#39;, &#39;bas&#39;, &#39;NE&#39;, &#39;SE&#39;, &#39;SO&#39;, &#39;NO&#39;</span>
<span class="sd">        :type direction: str  </span>
<span class="sd">        </span>
<span class="sd">        :return: un couple de coordonnée entières (x&#39;, y&#39;) du pixel voisin de celui de coordonnée (x,y) dans la direction indiquée par la variable direction. </span>
<span class="sd">        :rtype: int*int</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        
        <span class="k">if</span> <span class="n">direction</span><span class="o">==</span><span class="s1">&#39;droite&#39;</span><span class="p">:</span>
            <span class="k">return</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x</span><span class="o">+</span><span class="mi">1</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">y</span><span class="p">)</span>
        <span class="k">elif</span> <span class="n">direction</span><span class="o">==</span><span class="s1">&#39;gauche&#39;</span><span class="p">:</span>
            <span class="k">return</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">y</span><span class="p">)</span>
        <span class="k">elif</span> <span class="n">direction</span><span class="o">==</span><span class="s1">&#39;haut&#39;</span><span class="p">:</span>
            <span class="k">return</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">y</span><span class="o">-</span><span class="mi">1</span><span class="p">)</span>
        <span class="k">elif</span> <span class="n">direction</span><span class="o">==</span><span class="s1">&#39;bas&#39;</span><span class="p">:</span>
            <span class="k">return</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">y</span><span class="o">+</span><span class="mi">1</span><span class="p">)</span>
        <span class="k">elif</span> <span class="n">direction</span><span class="o">==</span><span class="s1">&#39;NE&#39;</span><span class="p">:</span>
            <span class="k">return</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x</span><span class="o">+</span><span class="mi">1</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">y</span><span class="o">-</span><span class="mi">1</span><span class="p">)</span>
        <span class="k">elif</span> <span class="n">direction</span><span class="o">==</span><span class="s1">&#39;SE&#39;</span><span class="p">:</span>
            <span class="k">return</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x</span><span class="o">+</span><span class="mi">1</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">y</span><span class="o">+</span><span class="mi">1</span><span class="p">)</span>
        <span class="k">elif</span> <span class="n">direction</span><span class="o">==</span><span class="s1">&#39;SO&#39;</span><span class="p">:</span>
            <span class="k">return</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">y</span><span class="o">+</span><span class="mi">1</span><span class="p">)</span>
        <span class="k">elif</span> <span class="n">direction</span><span class="o">==</span><span class="s1">&#39;NO&#39;</span><span class="p">:</span>
            <span class="k">return</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">y</span><span class="o">-</span><span class="mi">1</span><span class="p">)</span>
        <span class="k">else</span> <span class="p">:</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Erreur de paramètre dans Sommet.coord_voisin!&quot;</span><span class="p">)</span>  
            <span class="n">exit</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span> </div>
             
<div class="viewcode-block" id="Pixel.est_superieur"><a class="viewcode-back" href="../tec_doc.html#Gradient.Pixel.est_superieur">[docs]</a>    <span class="k">def</span> <span class="nf">est_superieur</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">pixel</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Pixel </span>
<span class="sd">        :type self: Pixel</span>
<span class="sd">        </span>
<span class="sd">        :param sommet: Objet Pixel</span>
<span class="sd">        :type sommet: Pixel  </span>
<span class="sd">        </span>
<span class="sd">        :return: True si la valeur de self est strictement plus grande que la valeur de pixel et False sinon</span>
<span class="sd">        :rtype: bool</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span> 
        
        <span class="k">return</span>  <span class="bp">self</span><span class="o">.</span><span class="n">val</span> <span class="o">&gt;</span> <span class="n">pixel</span><span class="o">.</span><span class="n">val</span>  </div>
        
<div class="viewcode-block" id="Pixel.est_inferieur"><a class="viewcode-back" href="../tec_doc.html#Gradient.Pixel.est_inferieur">[docs]</a>    <span class="k">def</span> <span class="nf">est_inferieur</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">pixel</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Pixel </span>
<span class="sd">        :type self: Pixel</span>
<span class="sd">        </span>
<span class="sd">        :param sommet: Objet Pixel</span>
<span class="sd">        :type sommet: Pixel  </span>
<span class="sd">        </span>
<span class="sd">        :return: True si la valeur de self est strictement plus petite que la valeur de pixel et False sinon</span>
<span class="sd">        :rtype: bool</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span> 
        
        <span class="k">return</span>  <span class="bp">self</span><span class="o">.</span><span class="n">val</span> <span class="o">&lt;</span> <span class="n">pixel</span><span class="o">.</span><span class="n">val</span> </div>
            
<div class="viewcode-block" id="Pixel.affiche_pixel"><a class="viewcode-back" href="../tec_doc.html#Gradient.Pixel.affiche_pixel">[docs]</a>    <span class="k">def</span> <span class="nf">affiche_pixel</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Affiche les coordonnées de self</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Sommet </span>
<span class="sd">        :type self: Sommet</span>
<span class="sd">        </span>
<span class="sd">        :return: None </span>
<span class="sd">        :rtype: None object</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;(&quot;</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">x</span><span class="p">,</span><span class="s2">&quot;;&quot;</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">y</span><span class="p">,</span><span class="s2">&quot;) ;&quot;</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">val</span><span class="p">,</span><span class="s2">&quot;;&quot;</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">zone</span><span class="p">)</span>        </div></div>
</pre></div>

          </div>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="Index général"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Index des modules Python"
             >modules</a> |</li>
<li><a href="../index.html">Segmentation Image home</a>| </li>
<li><a href="../contents.html">Documentation </a> &raquo;</li>

          <li class="nav-item nav-item-1"><a href="index.html" >Code du module</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2019, Cecile Prouteau.
      Créé avec <a href="http://sphinx-doc.org/">Sphinx</a> 1.7.9.
    </div>
  </body>
</html>